import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);

		// Read the number of paragraphs and page width
		int paragraph_no, paragraphs = scanner.nextInt();
		
		for (paragraph_no = 1; paragraph_no <= paragraphs; paragraph_no++) {

			// Each case has its own local variables ...
			int i, j;

			// Read n, D and then the array d[i] and e[i]
			int n = scanner.nextInt();
			int maxWidth = scanner.nextInt();
			scanner.nextLine(); // Eat the newline after the last number
			
			String[] words = new String[n];
			for (i = 0; i < n; i++) {
				words[i] = scanner.nextLine();
			}

			// TODO: Put your implementation here
			
			// Best possible penalty up to the i-th word if we break just after i-th word
			int[] penalty = new int[n];
			// If we break just after i-th word, after what word is the previous break to
			// get the optimal solution? -1 for the start of the text.
			int[] lastBreak = new int[n];
			
			for (i = 0; i < n; i++) {
				penalty[i] = Integer.MAX_VALUE;
				
				// Consider the line ending with i-th word to be just that word 
				int currentWidth = words[i].length();
				
				// Include the words before i-th into the hypothetical last line, one by one. 
				for (j = i - 1; (j >= 0) && (currentWidth <= maxWidth); j--) {
					// Compute penalty of words j+1 .. i (e.g. broken just after j-th word)
					int currentPenalty = penalty[j];
					// The last line with the last word is exceptional, others are penalized
					if (i < n - 1) {
						currentPenalty += (maxWidth - currentWidth) * (maxWidth - currentWidth);
					}
					// Remember the best option with HIGHEST possible j, if more are equal,
					// which gives the longest previous line, as required
					if (currentPenalty < penalty[i]) {
						penalty[i] = currentPenalty;
						lastBreak[i] = j;
					}
					// Include j-th word into the last line 
					currentWidth += words[j].length() + 1;
				}
				
				// If currentWidth <= maxWidth, then we have included even the 0-th word into currentWidth	
				// and we also consider the line to contain all the words so far.
				if (currentWidth <= maxWidth) {
					int currentPenalty = 0;
					// The last line with the last word is exceptional, others are penalized
					if (i < n - 1) {
						currentPenalty += (maxWidth - currentWidth) * (maxWidth - currentWidth);
					}
					// As above, we still want to take the highest previous break with the same score:
					if (currentPenalty < penalty[i]) {
						penalty[i] = currentPenalty;
						lastBreak[i] = j;
					}
				}
			}

			// Output the total penalty
			System.out.println(penalty[n - 1]);
		}
		
		scanner.close();
	}
}
